/*
 *	Dec 1996 - Mathijs Maassen PE1NTP @ PI8DAZ.#TWE.NLD.EU || tyz@xs4all.nl
 */

#include <stdio.h>
#include <string.h>


void printenv(char *var, char *val)
{
	printf("%s='%s' ; export %s\n", var, val, var);
}

void scan_server_in(char *fname)
{
	FILE *fp;
	char line[128], call[7], home[7], *p, *p2;

	if ((fp = fopen(fname, "r")) == NULL) {
		perror(fname);
		exit(2);
	}

	fgets(line, sizeof(line), fp);
	if (sscanf(line, "SP %*s < %6s", call) != 1) {
		fprintf(stderr, "%s: Wrong number of arguments on 1st line\n", fname);
		exit(3);
	}
	printenv("SENDER", call);

	fgets(line, sizeof(line), fp);
	line[strlen(line) - 1] = '\0';
	printenv("SUBJECT", line);

	home[0] = '\0';

	while (fgets(line, sizeof(line), fp) != NULL) {
		if (line[0] != 'R' || line[1] != ':')
			break;
		if ((p = strchr(line, '@')) == NULL)
			break;
		if (*(++p) == ':')
			p++;
		if ((p2 = strpbrk(p, ".\t\n ")) == NULL)
			break;
		*p2 = '\0';
		strncpy(home, p, 6);
		home[6] = '\0';
	}

	if (home[0]) {
		printenv("HOMEBBS", home);
	}

	fclose(fp);
}

void scan_init_srv(void)
{
	FILE *fp;
	char line[128], *infarr[] = { "BBSCALL", "", "", "", "SYSTEMDIR", "MAILDIR", "", "USERSDIR", "YAPPDIR", "DOCSDIR", "", "SYSOPCALL", "", "MAILIN" };
	int lineno = 0;

	if ((fp = fopen("init.srv", "r")) == NULL) {
		perror("init.srv");
		exit(4);
	}

	while (fgets(line, sizeof(line), fp) != NULL) {
		if (line[0] == '#')
			continue;
		line[strlen(line) - 1] = '\0';
		if (infarr[lineno][0])
			printenv(infarr[lineno], line);
		if (lineno++ == 13)
			break;
	}

	fclose(fp);
}

int main(int argc, char **argv)
{
	if (argc != 2) {
		fprintf(stderr, "getservinfo v0.1 - (c) 1996 Mathijs Maassen PE1NTP @ PI8DAZ.#TWE.NLD.EU\n");
		return (1);
	}

	scan_server_in(argv[1]);
	scan_init_srv();

	return (0);
}
